## ros-iron-libyaml-vendor 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(libyaml_vendor)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # About -Wno-sign-conversion: With Clang, -Wconversion implies -Wsign-conversion. There are a number of
  # implicit sign conversions in rclcpp and gtest.cc, see https://ci.ros2.org/job/ci_osx/9265/.
  # Hence disabling -Wsign-conversion for now until all those have eventually been fixed.
  # (from https://github.com/ros2/rclcpp/pull/1188#issuecomment-650229140)
  add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

option(FORCE_BUILD_VENDOR_PKG
  "Build libyaml from source, even if system-installed package is available"
  OFF)

find_package(ament_cmake REQUIRED)
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

if(NOT FORCE_BUILD_VENDOR_PKG)
  find_package(yaml QUIET)
endif()

macro(build_libyaml)
  set(extra_cmake_args)

  get_property(multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(NOT multi_config AND DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()

  list(APPEND extra_cmake_args -DBUILD_SHARED_LIBS=ON)
  list(APPEND extra_cmake_args -DBUILD_TESTING=OFF)
  list(APPEND extra_cmake_args -DCMAKE_C_FLAGS=${CMAKE_C_FLAGS})
  # Disable MSVC warnings
  if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
    set(win_c_flags "${CMAKE_C_FLAGS} /wd4244 /wd4267 /wd4996")
    list(APPEND extra_cmake_args -DCMAKE_C_FLAGS=${win_c_flags})

    if(DEFINED CMAKE_SYSTEM_NAME)
      list(APPEND extra_cmake_args "-DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}")
    endif()
    if(DEFINED CMAKE_SYSTEM_VERSION)
      list(APPEND extra_cmake_args "-DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}")
    endif()
  endif()

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
    if(ANDROID)
      if(DEFINED ANDROID_ABI)
        list(APPEND extra_cmake_args "-DANDROID_ABI=${ANDROID_ABI}")
      endif()
      if(DEFINED ANDROID_CPP_FEATURES)
        list(APPEND extra_cmake_args "-DANDROID_CPP_FEATURES=${ANDROID_CPP_FEATURES}")
      endif()
      if(DEFINED ANDROID_FUNCTION_LEVEL_LINKING)
        list(APPEND extra_cmake_args "-DANDROID_FUNCTION_LEVEL_LINKING=${ANDROID_FUNCTION_LEVEL_LINKING}")
      endif()
      if(DEFINED ANDROID_NATIVE_API_LEVEL)
        list(APPEND extra_cmake_args "-DANDROID_NATIVE_API_LEVEL=${ANDROID_NATIVE_API_LEVEL}")
      endif()
      if(DEFINED ANDROID_NDK)
        list(APPEND extra_cmake_args "-DANDROID_NDK=${ANDROID_NDK}")
      endif()
      if(DEFINED ANDROID_STL)
        list(APPEND extra_cmake_args "-DANDROID_STL=${ANDROID_STL}")
      endif()
      if(DEFINED ANDROID_TOOLCHAIN_NAME)
        list(APPEND extra_cmake_args "-DANDROID_TOOLCHAIN_NAME=${ANDROID_TOOLCHAIN_NAME}")
      endif()
    endif()
  endif()
  include(ExternalProject)
  externalproject_add(libyaml-0.2.5
    GIT_REPOSITORY https://github.com/yaml/libyaml.git
    GIT_TAG 2c891fc7a770e8ba2fec34fc6b545c672beb37e6  # 0.2.5
    GIT_CONFIG advice.detachedHead=false
    # Suppress git update due to https://gitlab.kitware.com/cmake/cmake/-/issues/16419
    # See https://github.com/ament/uncrustify_vendor/pull/22 for details
    UPDATE_COMMAND ""
    TIMEOUT 600
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/libyaml_install
      -DINSTALL_INCLUDE_DIR:STRING=include/${PROJECT_NAME}
      ${extra_cmake_args}
    PATCH_COMMAND
      ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn
        ${CMAKE_CURRENT_SOURCE_DIR}/0001-Install-yaml.h-to-INSTALL_INCLUDE_DIR.patch
  )

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/libyaml_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}
    USE_SOURCE_PERMISSIONS
    PATTERN config.h EXCLUDE
  )

  set(yaml_INCLUDE_DIRS ${CMAKE_CURRENT_BINARY_DIR}/libyaml_install/include/${PROJECT_NAME})
  set(yaml_LIBRARY_DIRS ${CMAKE_CURRENT_BINARY_DIR}/libyaml_install/lib)
  set(yaml_LIBRARIES yaml)
endmacro()

# Skip building yaml if the expected version is already present in the system
if(yaml_FOUND)
  if("${yaml_VERSION}" VERSION_EQUAL 0.2.5)
    set(_SKIP_YAML_BUILD 1)
  endif()
endif()

if(NOT _SKIP_YAML_BUILD)
  build_libyaml()
  set(extra_test_dependencies libyaml-0.2.5)
endif()

ament_export_dependencies(yaml)

if(BUILD_TESTING)
  # We need to install a Findyaml.cmake file that does not respect
  # ament_cmake_lint_cmake's convention/filename and package/stdargs rules
  # See https://github.com/ros2/libyaml_vendor/pull/45#issuecomment-1087559657
  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_lint_cmake
  )
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  find_package(ament_cmake_lint_cmake REQUIRED)
  ament_lint_cmake("--filter=-convention/filename,-package/stdargs")

  find_package(ament_cmake_gtest REQUIRED)
  find_package(rcpputils REQUIRED)
  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS
    performance_test_fixture::performance_test_fixture INTERFACE_INCLUDE_DIRECTORIES)

  if(${CMAKE_VERSION} VERSION_LESS "3.13")
    link_directories(${yaml_LIBRARY_DIRS})
  endif()

  ament_add_gtest(test_yaml_reader test/test_reader.cpp
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
  if(TARGET test_yaml_reader)
    target_include_directories(test_yaml_reader PRIVATE ${yaml_INCLUDE_DIRS})
    target_link_libraries(test_yaml_reader ${yaml_LIBRARIES})
    if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
      target_link_directories(test_yaml_reader PRIVATE ${yaml_LIBRARY_DIRS})
    endif()
    ament_target_dependencies(test_yaml_reader rcpputils)
    if(extra_test_dependencies)
      add_dependencies(test_yaml_reader ${extra_test_dependencies})
    endif()
  endif()

  add_performance_test(benchmark_reader test/benchmark/benchmark_reader.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
  ament_target_dependencies(benchmark_reader rcpputils)
  if(TARGET benchmark_reader)
    target_include_directories(benchmark_reader PRIVATE ${yaml_INCLUDE_DIRS})
    target_link_libraries(benchmark_reader ${yaml_LIBRARIES})
    if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
      target_link_directories(benchmark_reader PRIVATE ${yaml_LIBRARY_DIRS})
    endif()
    if(extra_test_dependencies)
      add_dependencies(benchmark_reader ${extra_test_dependencies})
    endif()
  endif()
endif()

install(DIRECTORY cmake DESTINATION share/${PROJECT_NAME})

ament_package(CONFIG_EXTRAS libyaml_vendor-extras.cmake)

=== debian/changelog ===
ros-iron-libyaml-vendor (1.5.0-3jammy) jammy; urgency=high

  * Fix system package dependency (#54 <https://github.com/ros2/libyaml_vendor/issues/54>)
  * Update libyaml_vendor to C++17. (#55 <https://github.com/ros2/libyaml_vendor/issues/55>)
  * [rolling] Update maintainers - 2022-11-07 (#53 <https://github.com/ros2/libyaml_vendor/issues/53>)
  * Contributors: Audrow Nash, Chris Lalancette, Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Sun, 12 Feb 2023 16:00:00 -0000

ros-iron-libyaml-vendor (1.4.2-3jammy) jammy; urgency=high

  * Remove a warning message. (#51 <https://github.com/ros2/libyaml_vendor/issues/51>)
  * check if libyaml is already present before building it (take 2) (#45 <https://github.com/ros2/libyaml_vendor/issues/45>)
  * Contributors: Chris Lalancette, Silvio Traversaro

 -- Scott K Logan <scott@openrobotics.org>  Tue, 01 Nov 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.4.1-3jammy) jammy; urgency=high

  * Mirror rolling to master
  * Support WindowsStore builds for ROS2 (#50 <https://github.com/ros2/libyaml_vendor/issues/50>)
    * libyaml for uwp
  * Contributors: Audrow Nash, Lou Amadio

 -- Scott K Logan <scott@openrobotics.org>  Mon, 12 Sep 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.4.0-3jammy) jammy; urgency=high



 -- Scott K Logan <scott@openrobotics.org>  Tue, 03 May 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.3.0-3jammy) jammy; urgency=high



 -- Scott K Logan <scott@openrobotics.org>  Thu, 28 Apr 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.2.2-3jammy) jammy; urgency=high

  * Add a buildtool dependency on git. (#48 <https://github.com/ros2/libyaml_vendor/issues/48>)
  * Contributors: Steven! Ragnarök

 -- Scott K Logan <scott@openrobotics.org>  Wed, 30 Mar 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.2.1-3jammy) jammy; urgency=high

  * Install headers to include/${PROJECT_NAME} (#46 <https://github.com/ros2/libyaml_vendor/issues/46>)
  * Merge pull request #43 <https://github.com/ros2/libyaml_vendor/issues/43> from ros2/update-maintainers
  * Update maintainers to Audrow Nash
  * Contributors: Audrow Nash, Shane Loretz

 -- Scott K Logan <scott@openrobotics.org>  Sun, 27 Mar 2022 16:00:00 -0000

ros-iron-libyaml-vendor (1.2.0-3jammy) jammy; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#38 <https://github.com/ros2/libyaml_vendor/issues/38>)
  * Update libyaml_vendor to 0.2.5. (#37 <https://github.com/ros2/libyaml_vendor/issues/37>)
  * Contributors: Chris Lalancette, shonigmann

 -- Scott K Logan <scott@openrobotics.org>  Mon, 05 Apr 2021 16:00:00 -0000

ros-iron-libyaml-vendor (1.1.1-3jammy) jammy; urgency=high

  * Fix linker flags for tests when CMake < 3.13 (#35 <https://github.com/ros2/libyaml_vendor/issues/35>)
  * Always preserve source permissions in vendor packages (#31 <https://github.com/ros2/libyaml_vendor/issues/31>)
  * Contributors: Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Tue, 09 Mar 2021 16:00:00 -0000

ros-iron-libyaml-vendor (1.1.0-3jammy) jammy; urgency=high

  * Fix target_link_directories/link_directories in cmake (#29 <https://github.com/ros2/libyaml_vendor/issues/29>)
  * Included benchmark tests (#20 <https://github.com/ros2/libyaml_vendor/issues/20>)
  * Update Quality Declaration (#23 <https://github.com/ros2/libyaml_vendor/issues/23>)
  * Update package maintainers. (#22 <https://github.com/ros2/libyaml_vendor/issues/22>)
  * Bump QD to 3 and some minor style fixes (#19 <https://github.com/ros2/libyaml_vendor/issues/19>)
  * Add Security Vulnerability Policy pointing to REP-2006. (#18 <https://github.com/ros2/libyaml_vendor/issues/18>)
  * Add quality declaration libyaml_vendor (#12 <https://github.com/ros2/libyaml_vendor/issues/12>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Jorge Perez, Michel Hidalgo

 -- Scott K Logan <scott@openrobotics.org>  Sun, 24 Jan 2021 16:00:00 -0000

ros-iron-libyaml-vendor (1.0.2-3jammy) jammy; urgency=high

  * Quality declaration for external dependency libyaml (#14 <https://github.com/ros2/libyaml_vendor/issues/14>)
  * Add missing Contributing.md file (#17 <https://github.com/ros2/libyaml_vendor/issues/17>)
  * Export modern CMake interface target (#16 <https://github.com/ros2/libyaml_vendor/issues/16>)
  * Contributors: Dirk Thomas, Jorge Perez

 -- Scott K Logan <scott@openrobotics.org>  Wed, 06 May 2020 16:00:00 -0000

ros-iron-libyaml-vendor (1.0.1-3jammy) jammy; urgency=high

  * Add missing export of yaml (#15 <https://github.com/ros2/libyaml_vendor/issues/15>)
  * Only propagate CMAKE_BUILD_TYPE for single configuration generators (#13 <https://github.com/ros2/libyaml_vendor/issues/13>)
  * Enable linter tests on libyaml_vendor (#8 <https://github.com/ros2/libyaml_vendor/issues/8>)
  * Add missing LICENSE file, apache2 (#7 <https://github.com/ros2/libyaml_vendor/issues/7>)

 -- Scott K Logan <scott@openrobotics.org>  Thu, 23 Apr 2020 16:00:00 -0000

ros-iron-libyaml-vendor (1.0.0-3jammy) jammy; urgency=high

  * remove version from CMake, use the one from package.xml instead (#5 <https://github.com/ros2/libyaml_vendor/issues/5>)
    * remove version from CMake, use the one from package.xml instead
    * removing version keyword as well
  * Export libyaml library (#4 <https://github.com/ros2/libyaml_vendor/issues/4>)
    * Export libyaml library
    * Remove lib prefix
  * Added support for Android (#2 <https://github.com/ros2/libyaml_vendor/issues/2>)
  * create libyaml_vendor (#1 <https://github.com/ros2/libyaml_vendor/issues/1>)
    * create libyaml
    * Don't install to include/config.h
  * Initial commit
  * Contributors: Mickael Gaillard, Mikael Arguedas, dhood

 -- Scott K Logan <scott@openrobotics.org>  Sun, 24 Jun 2018 16:00:00 -0000

=== debian/control ===
Source: ros-iron-libyaml-vendor
Section: misc
Priority: optional
Maintainer: Scott K Logan <scott@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), git, libyaml-dev, pkg-config, ros-iron-ament-cmake, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-performance-test-fixture <!nocheck>, ros-iron-rcpputils <!nocheck>, ros-iron-rcutils <!nocheck>, ros-iron-ros-workspace
Homepage: https://github.com/yaml/libyaml
Standards-Version: 3.9.2

Package: ros-iron-libyaml-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-0-2, libyaml-dev, pkg-config, ros-iron-ros-workspace
Description: Vendored version of libyaml.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-libyaml-vendor//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
